## pocl 6.0

=== CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014-2023 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
cmake_policy(SET CMP0067 OLD)

project(pocl)
set(CMAKE_PROJECT_DESCRIPTION "pocl is a portable OpenCl runtime.")

MESSAGE(STATUS "CMAKE_SYSTEM_NAME: ${CMAKE_SYSTEM_NAME}")
MESSAGE(STATUS "CMAKE_SYSTEM_PROCESSOR: ${CMAKE_SYSTEM_PROCESSOR}")
MESSAGE(STATUS "CMAKE_LIBRARY_ARCHITECTURE: ${CMAKE_LIBRARY_ARCHITECTURE}")

set(LATEST_KNOWN_CXX_STD_VERSION "20")
set(SUPPORTED_CXX_STD_VERSION "11")

option(ENABLE_LATEST_CXX_STD "Upgrade C++ standard version to ${LATEST_KNOWN_CXX_STD_VERSION}. Required to get rid of unused variables warnings in compilers not supporting [[gnu::*]] attributes. Can bring other benefits, including performance and efficiency ones. Before a pull request build with this disabled." OFF)
if(ENABLE_LATEST_CXX_STD)
	set(CMAKE_CXX_STANDARD "${LATEST_KNOWN_CXX_STD_VERSION}")
else()
	set(CMAKE_CXX_STANDARD "${SUPPORTED_CXX_STD_VERSION}")
endif()
set(POCL_CMAKE_CXX_STANDARD ${CMAKE_CXX_STANDARD})
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# if variable FEATURE_X isn't defined, sets it to DEFAULT_FEATURE_X;
# also, if DEFAULT_FEATURE_X is 0, prevents FEATURE_X being 1
# since it takes DEFAULT_FEATURE_X=0 to mean "FEATURE_X is unavailable"
macro(setup_cached_var VARNAME DESCRIPTION DOCS_FEATURE_IS_UNAVAILABLE DOCS_REQUESTED_DISABLING_FEATURE)

  if(DEFINED ${VARNAME})
    set(_CACHED "(cached)")
  else()
    set(_CACHED "")
    set(${VARNAME} ${DEFAULT_${VARNAME}})
  endif()

  if(${VARNAME} AND (NOT ${DEFAULT_${VARNAME}}))
    message(WARNING "${DOCS_FEATURE_IS_UNAVAILABLE}")
    set(${VARNAME} 0)
    set(_CACHED "(override)")
  endif()
  if((NOT ${VARNAME}) AND ${DEFAULT_${VARNAME}} )
    message(STATUS "${DOCS_REQUESTED_DISABLING_FEATURE}")
  endif()
  if(${VARNAME})
    message(STATUS "${DESCRIPTION} ${_CACHED}: 1")
  else()
    message(STATUS "${DESCRIPTION} ${_CACHED}: 0")
  endif()
endmacro()

include(CheckCCompilerFlag)
include(CPackComponent)
macro(pass_through_cpack_vars)
  get_cmake_property(cpackVarsToPassthrough VARIABLES)
  foreach(varName ${cpackVarsToPassthrough})
    if(varName MATCHES "^CPACK_DEBIAN_")
      message(STATUS "${varName}")
      set("${varName}" "${${varName}}" PARENT_SCOPE)
    endif()
  endforeach()
endmacro()

# don't allow implicit function declarations
if(UNIX)
  if((CMAKE_C_COMPILER_ID STREQUAL "GNU") OR
     (CMAKE_C_COMPILER_ID STREQUAL "Clang"))

    check_c_compiler_flag("-Wincompatible-pointer-types" HAVE_WARN_INCOMPATIBLE_POINTER_TYPES)
    set(FORBID_IMPLICIT_FUNCTIONS "-Werror=implicit-function-declaration")
    if (HAVE_WARN_INCOMPATIBLE_POINTER_TYPES)
        set(FORBID_IMPLICIT_FUNCTIONS ${FORBID_IMPLICIT_FUNCTIONS} "-Werror=incompatible-pointer-types")
    endif()
    add_compile_options("$<$<COMPILE_LANGUAGE:C>:${FORBID_IMPLICIT_FUNCTIONS}>")

    add_compile_options("-Wno-ignored-attributes")

  else()
    message(WARNING "Don't know how to forbid this compiler from allowing implicit function declarations.")
  endif()
endif()

set(MAJOR_VERSION 6)
set(MINOR_VERSION 0)
set(VERSION_SUFFIX_FIXED_TEXT "")
set(VERSION_SUFFIX "${VERSION_SUFFIX_FIXED_TEXT}")
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}${VERSION_SUFFIX})
set(POCL_VERSION_BASE ${VERSION_STRING})

# required b/c SHARED libs defaults to ON while OBJECT defaults to OFF
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
# CMake doesn't add "-pie" by default for executables (CMake issue #14983)
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")

enable_testing()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#####################################################

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  set(DEFAULT_BUILD_TYPE "Debug")
else()
  set(DEFAULT_BUILD_TYPE "RelWithDebInfo")
endif()

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(LLVM_VERIFY_MODULE_DEFAULT 1)
else()
  set(LLVM_VERIFY_MODULE_DEFAULT 0)
endif()

##################################################################################

macro(set_expr VAR)
  if(${ARGN})
    set(${VAR} 1)
  else()
    set(${VAR} 0)
  endif()
endmacro()

find_program(BASH "bash")
find_program(MAKE_PROGRAM NAMES "make")
find_program(GIT_CMD "git")
set_expr(HAVE_GIT GIT_CMD)

if(HAVE_GIT)
  execute_process(COMMAND "${GIT_CMD}" "rev-parse" "HEAD"
                  OUTPUT_VARIABLE GIT_COMMIT
                  RESULT_VARIABLE EXITCODE
                  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

if(HAVE_GIT AND (VERSION_SUFFIX MATCHES "pre") AND (EXITCODE EQUAL 0))
  message(STATUS "Pocl source Git commit: ${GIT_COMMIT}")

  execute_process(COMMAND "${GIT_CMD}" "branch" "--contains" "${GIT_COMMIT}"
                  OUTPUT_VARIABLE GIT_BRANCH
                  RESULT_VARIABLE EXITCODE
                  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  message(STATUS "Pocl source Git branch: ${GIT_BRANCH}")

  execute_process(COMMAND "${GIT_CMD}" describe "--always" "--long" "--all" "${GIT_COMMIT}"
                  OUTPUT_VARIABLE GIT_DESCRIBE
                  RESULT_VARIABLE EXITCODE
                  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                  OUTPUT_STRIP_TRAILING_WHITESPACE)

  string(REPLACE "heads/" "" GIT_DESCRIBE "${GIT_DESCRIBE}")
  message(STATUS "Pocl source Git describe: ${GIT_DESCRIBE}")
  set(VERSION_SUFFIX "${VERSION_SUFFIX_FIXED_TEXT} ${GIT_DESCRIBE}")
  set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}${VERSION_SUFFIX})
  set(POCL_VERSION_FULL "${VERSION_STRING}")
else()
  message(STATUS "No git and/or not a prerelease -> not adding git commit to version.")
  set(POCL_VERSION_FULL "${POCL_VERSION_BASE}")
endif()

set(CPACK_PACKAGE_NAME pocl)
set(CPACK_PACKAGE_VENDOR pocl)
set(CPACK_PACKAGE_VERSION_MAJOR "${MAJOR_VERSION}")
set(CPACK_PACKAGE_VERSION_MINOR "${MINOR_VERSION}")
set(CPACK_PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}~${VERSION_SUFFIX_FIXED_TEXT}")
if(HAVE_GIT)
       set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION}.${GIT_COMMIT}")
endif()

##################################################################################

option(ENABLE_LLVM "Build pocl with LLVM. Default is ON." ON)

option(STATIC_LLVM "If ON, link to static LLVM libraries. OFF (default) = link to shared LLVM libraries." OFF)

option(BUILD_SHARED_LIBS "ON=Build shared libs, OFF=static libs" ON)

option(POCL_DEBUG_MESSAGES
  "Enable debug messages from pocl (useful for OpenCL developers), must be enabled at runtime, with env var POCL_DEBUG"
  ON)

option(ENABLE_LOADABLE_DRIVERS "Enable drivers to be dlopen()-ed at pocl runtime, instead of being linked into libpocl" ON)

option(ENABLE_HSA "Enable the HSA base profile runtime device driver" OFF)

option(ENABLE_CUDA "Enable the CUDA device driver for NVIDIA devices" OFF)

option(ENABLE_CUDNN "Enable the CUDNN for the CUDA device driver, requires CUDA" OFF)

option(ENABLE_VULKAN "Experimental and incomplete driver that uses the Vulkan API for controlling the device. Please refer to the user manual for the status and open tasks" OFF)

option(ENABLE_LEVEL0 "Experimental and incomplete driver that uses the Level Zero API for controlling the device. Please refer to the user manual for the status and open tasks" OFF)

option(ENABLE_TBB_DEVICE "Enable the Intel TBB device driver." OFF)

option(ENABLE_HOST_CPU_DEVICES "Add host CPUs as OpenCL devices (cpu & cpu-minimal)." ON)

option(ENABLE_HOST_CPU_DEVICES_OPENMP "Enables OpenMP support for Host CPU devices (cpu driver only, cpu-minimal driver remains single-threaded)" OFF)

option(ENABLE_PROXY_DEVICE "Enable proxy driver for proxying to another OpenCL implementation" OFF)

option(ENABLE_PROXY_DEVICE_INTEROP "Enable OpenGL- or EGL-interop with the proxy driver" OFF)

option(ENABLE_ALMAIF_DEVICE "Enable the generic hardware accelerator device driver." OFF)

option(KERNEL_CACHE_DEFAULT "Default value for the kernel compile cache. If disabled, pocl will still use kernel cache for intermediate compilation files, but will clean up them on exit. You can still enable keeping the files it at runtime with an env var." ON)

option(ENABLE_REMOTE_SERVER "Build the 'pocld' server daemon for the remote driver" OFF)

option(ENABLE_REMOTE_CLIENT "Build the client library of the remote driver" OFF)

option(POCL_ICD_ABSOLUTE_PATH "Use absolute path in pocl.icd" ON)

option(ENABLE_POCL_BUILDING "When OFF, env var POCL_BUILDING has no effect. Defaults to ON" ON)

option(ENABLE_PRINTF_IMMEDIATE_FLUSH "[currently only applies to CPU drivers] if enabled, printf is flushed immediately when encountered, instead of after all NDRange workgroups are finished" ON)

option(ENABLE_VSOCK "Enable vsock transport in the remote driver" OFF)

if (ENABLE_PROXY_DEVICE)
  set(VISIBILITY_HIDDEN_DEFAULT OFF)
else()
  set(VISIBILITY_HIDDEN_DEFAULT ON)
endif()
option(VISIBILITY_HIDDEN "Build with -fvisibility=hidden -fvisibility-inlines-hidden" ${VISIBILITY_HIDDEN_DEFAULT})
if(VISIBILITY_HIDDEN)
  add_compile_options(-fvisibility=hidden)
  add_compile_options($<$<COMPILE_LANGUAGE:CXX>:-fvisibility-inlines-hidden>)
endif()


# Ninja Job Pool support
set(PARALLEL_COMPILE_JOBS "" CACHE STRING
  "Define the maximum number of concurrent compilation jobs (Ninja only).")
if(PARALLEL_COMPILE_JOBS)
  if(CMAKE_GENERATOR STREQUAL "Ninja")
    set_property(GLOBAL APPEND PROPERTY JOB_POOLS compile_job_pool=${PARALLEL_COMPILE_JOBS})
    set(CMAKE_JOB_POOL_COMPILE compile_job_pool)
  endif()
endif()

set(PARALLEL_LINK_JOBS "" CACHE STRING
  "Define the maximum number of concurrent link jobs (Ninja only).")
if(CMAKE_GENERATOR STREQUAL "Ninja")
  if(PARALLEL_LINK_JOBS)
    set_property(GLOBAL APPEND PROPERTY JOB_POOLS link_job_pool=${PARALLEL_LINK_JOBS})
    set(CMAKE_JOB_POOL_LINK link_job_pool)
  endif()
endif()

if(NOT CMAKE_GENERATOR STREQUAL "Ninja" AND (PARALLEL_COMPILE_JOBS OR PARALLEL_LINK_JOBS))
  message(WARNING "Job pooling is only available with Ninja generators.")
endif()

#### these are mostly useful for pocl developers

option(ENABLE_EXTRA_VALIDITY_CHECKS "Enable extra checks on cl_* object validity" OFF)

option(DEVELOPER_MODE "This will SIGNIFICANTLY reduce PoCL's performance, but speeds up its compilation for faster development-test cycles. Only turn on if you know what you're doing." OFF)

=== include/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

if(INSTALL_OPENCL_HEADERS)
  add_subdirectory("CL")
  add_subdirectory("hpp/CL")
endif()

set(PRIVATE_HEADERS _enable_all_exts.h _builtin_renames.h
                    _kernel.h _clang_opencl.h
                    _kernel_c.h _kernel_constants.h _libclang_versions_checks.h
                    pocl_types.h pocl_device.h pocl.h pocl_spir.h
                    pocl_image_types.h)

cpack_add_component("dev")

install(FILES ${PRIVATE_HEADERS}
        DESTINATION ${POCL_INSTALL_PRIVATE_HEADER_DIR} COMPONENT "dev")

=== lib/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2014 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

separate_arguments(HOST_CLANG_FLAGS)
separate_arguments(HOST_LLC_FLAGS)

# these are hardcoded here b/c we want to build the library with latest OpenCL
add_definitions(-DCL_TARGET_OPENCL_VERSION=300 -DCL_HPP_TARGET_OPENCL_VERSION=300)
include_directories("${CMAKE_SOURCE_DIR}/include" "${CMAKE_SOURCE_DIR}/include/hpp")

cpack_add_component("lib")

set("CPACK_DEBIAN_LIB_PACKAGE_NAME" "libpocl2")
set(CPACK_DEBIAN_LIB_PACKAGE_DEPENDS "libgcc1;libc6")
if(ENABLE_HWLOC)
	if( LLVM_VERSION_MAJOR LESS 12)
		set(HWLOC_NUMBER_PART 5)
	else()
		set(HWLOC_NUMBER_PART 15)
	endif()
	list(APPEND CPACK_DEBIAN_LIB_PACKAGE_DEPENDS "libhwloc${HWLOC_NUMBER_PART} (>= ${Hwloc_VERSION}~)")
endif()
if(ENABLE_LLVM)
	list(APPEND CPACK_DEBIAN_LIB_PACKAGE_DEPENDS "libllvm${LLVM_VERSION_MAJOR} (>= ${LLVM_VERSION_MAJOR}~);clang-${LLVM_VERSION_MAJOR} (>= ${LLVM_VERSION_MAJOR}~)")
endif()
string(REPLACE ";" ", " CPACK_DEBIAN_LIB_PACKAGE_DEPENDS "${CPACK_DEBIAN_LIB_PACKAGE_DEPENDS}")
set(CPACK_DEBIAN_LIB_PACKAGE_RECOMMENDS "pocl-opencl-icd")
set(CPACK_DEBIAN_LIB_PACKAGE_BREAKS "libpocl1-common (<< 0.13-9)")
set(CPACK_DEBIAN_LIB_PACKAGE_REPLACES "libpocl1-common (<< 0.13-9)")
 

if (ENABLE_LLVM)
  add_subdirectory("kernel")
  add_subdirectory("llvmopencl")
endif()

add_subdirectory("CL")

#############################################################

# must be after adding lib/CL subdir b/c of libpocl target,
# but before poclu & examples & tests (they need these variables)

if(ENABLE_ICD)

  # -pthread makes gdb happier when debugging tests
  set(OPENCL_LIBS "${PTHREAD_LIBRARY};${OPENCL_LIBRARIES}")

  if(OPENCL_LIBRARIES)
    if (NOT OPENCL_LIBDIR)
      get_filename_component(OPENCL_LIBDIR "${OPENCL_LIBRARIES}" DIRECTORY)
    endif()
    get_filename_component(OPENCL_LIBNAME "${OPENCL_LIBRARIES}" NAME)
  endif()

else()

  # when we link pocl directly as libOpenCL.so,
  # llvm+clang libs are a transitive dependency of
  # executables (e.g. poclcc -> libOpenCL -> libLLVM)
  # and this must be specified on new systems,
  # otherwise linking fails.
  set(OPENCL_LIBS "${PTHREAD_LIBRARY};${POCL_LIBRARY_NAME};${POCL_TRANSITIVE_LIBS}")

  set(OPENCL_LIBDIR "$<TARGET_FILE_DIR:${POCL_LIBRARY_NAME}>")
  set(OPENCL_LIBNAME "$<TARGET_FILE_NAME:${POCL_LIBRARY_NAME}>")

endif()


if(SANITIZER_OPTIONS)
  list(INSERT OPENCL_LIBS 0 ${SANITIZER_LIBS})
endif()

set(OPENCL_CFLAGS "")

set(OPENCL_CFLAGS_STR "${OPENCL_CFLAGS}")
separate_arguments(OPENCL_CFLAGS)

set(OPENCL_LIBS "${OPENCL_LIBS}" PARENT_SCOPE)
set(OPENCL_CFLAGS "${OPENCL_CFLAGS}" PARENT_SCOPE)
set(OPENCL_CFLAGS_STR "${OPENCL_CFLAGS_STR}" PARENT_SCOPE)
set(OPENCL_LIBDIR "${OPENCL_LIBDIR}" PARENT_SCOPE)
set(OPENCL_LIBNAME "${OPENCL_LIBNAME}" PARENT_SCOPE)

pass_through_cpack_vars()

=== pocld/CMakeLists.txt ===
#=============================================================================
#
#   CMake build system files
#
#   Copyright (c) 2019-2023 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

cmake_minimum_required(VERSION 3.0)
project(pocld)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

set(SOURCES pocld.cc daemon.hh daemon.cc cmdline.h cmdline.c
            ../lib/CL/pocl_debug.c ../lib/CL/pocl_debug.h
            ../lib/CL/pocl_threads.c ../lib/CL/pocl_threads.h
            ../lib/CL/pocl_timing.c ../lib/CL/pocl_timing.h
            ../lib/CL/devices/spirv_parser.hh ../lib/CL/devices/spirv_parser.cc
            ../lib/CL/devices/bufalloc.h ../lib/CL/devices/bufalloc.c
            ../lib/CL/pocl_networking.c ../lib/CL/pocl_networking.h
            ../lib/CL/pocl_runtime_config.c
            shared_cl_context.cc shared_cl_context.hh
            virtual_cl_context.cc virtual_cl_context.hh
            cmd_queue.cc cmd_queue.hh common.cc common.hh
            request.hh request.cc
            reply_th.cc reply_th.hh request_th.cc request_th.hh
            peer_handler.cc peer_handler.hh
            peer.cc peer.hh tracing.h traffic_monitor.hh traffic_monitor.cc)

# required b/c SHARED libs defaults to ON while OBJECT defaults to OFF
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

unset(P_INCLUDE_DIRECTORIES)
set(P_COMPILE_OPTIONS "-DPOCL_DEBUG_LOG_PREFIX=\"PoCL-D\"")
unset(P_LINK_LIST)

############################################
############################################

option(QUEUE_PROFILING "Enable profiling on server queues. Enabled by default" ON)

# CL/opencl.hpp
list(APPEND P_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/../include/hpp")

# messages.h + pocl_remote.h
list(APPEND P_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/../include")

list(APPEND P_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})
# pocld_config.h
list(APPEND P_INCLUDE_DIRECTORIES ${CMAKE_BINARY_DIR})
# pocl_debug.h + dependencies
list(APPEND P_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/../lib/CL")
# spirv_parser.hh
list(APPEND P_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/../lib/CL/devices")

############################################

if(RDMA_USE_SVM)
  set(ENABLE_RDMA 1)
endif()

if(ENABLE_RDMA)
    list(APPEND SOURCES
                rdma_request_th.cc rdma_request_th.hh
                rdma_reply_th.cc rdma_reply_th.hh
                rdma.cc rdma.hh)

    find_package(RDMAcm MODULE REQUIRED)
    find_package(Verbs MODULE REQUIRED)
    list(APPEND P_LINK_LIST RDMAcm::RDMAcm IBVerbs::verbs)
endif()

############################################

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
# we're building the server as a separate CMake project

  set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../cmake")

  set(STANDALONE 1)

  include(sanitizers)

  if (MSVC)
    message(FATAL_ERROR "Builds on Windows are only supported with MinGW and MSYS")
  endif()

  if(ENABLE_LTTNG AND UNIX AND (NOT CMAKE_CROSSCOMPILING))
    find_package(PkgConfig MODULE REQUIRED)
    pkg_check_modules(LTTNG_UST lttng-ust>=2.7)
    if(LTTNG_UST_FOUND)
      set(HAVE_LTTNG_UST 1)
    else()
      message(FATAL_ERROR "ENABLE_LTTNG enabled, but could not find library")
    endif()
  else()
    set(HAVE_LTTNG_UST 0)
  endif()

  if(OPENCL_LIBDIR)
    message(STATUS "Searching for OpenCL in extra paths: ${OPENCL_LIBDIR}")
    find_library(OPENCL NAMES OpenCL PATHS "${OPENCL_LIBDIR}" NO_DEFAULT_PATH)
  endif()
  find_library(OPENCL NAMES OpenCL)
  if (NOT OPENCL)
    message(FATAL_ERROR "Can't find libOpenCL")
  endif()
  message(STATUS "Linking pocld against this libOpenCL: ${OPENCL}")

  find_package(Threads REQUIRED)

  list(APPEND P_LINK_LIST ${OPENCL} Threads::Threads)

  set(POCL_INSTALL_PUBLIC_BINDIR "${CMAKE_INSTALL_PREFIX}/bin")

else()
# we're building the server as a part of pocl CMake project
  set(STANDALONE 0)

  list(APPEND P_LINK_LIST ${OPENCL_LIBS})

endif()

############################################

# pocld_config.h

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pocld_config.h.in.cmake" "${CMAKE_BINARY_DIR}/pocld_config.h" NEWLINE_STYLE UNIX)

############################################

if(SANITIZER_OPTIONS)
  if(ENABLE_ICD)
    message(FATAL_ERROR "Sanitizers don't work with ICD")
  endif()
  list(INSERT P_LINK_LIST 0 ${SANITIZER_LIBS})
endif()

############################################

if(HAVE_LTTNG_UST)
  list(APPEND P_COMPILE_OPTIONS ${LTTNG_UST_CFLAGS})
  list(APPEND SOURCES "pocld_lttng.c" "pocld_lttng.h")
  list(APPEND P_LINK_LIST ${LTTNG_UST_LDFLAGS})
endif()

###############################################################
###############################################################

add_executable(pocld ${SOURCES})

if(P_COMPILE_OPTIONS)
  message(STATUS "COMPILE OPTIONS: ${P_COMPILE_OPTIONS}")
  target_compile_options(pocld PRIVATE ${P_COMPILE_OPTIONS})
endif()
if(P_LINK_LIST)
  message(STATUS "LINK LIST: ${P_LINK_LIST}")
  target_link_libraries(pocld PRIVATE ${P_LINK_LIST})
endif()
if(P_INCLUDE_DIRECTORIES)
  message(STATUS "INCLUDE DIRS: ${P_INCLUDE_DIRECTORIES}")
  target_include_directories(pocld PRIVATE ${P_INCLUDE_DIRECTORIES})
endif()

target_include_directories(pocld PRIVATE ${CMAKE_BINARY_DIR}) # for config.h

set(CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set_property(TARGET pocld PROPERTY CXX_STANDARD 17)

if (STANDALONE EQUAL 0)
  install(TARGETS pocld RUNTIME
        DESTINATION "${POCL_INSTALL_PUBLIC_BINDIR}")
endif()

=== examples/AMDSDK3.0/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux" AND X86_64)

  set(TS_NAME AMDSDK3.0)
  set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
  set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
  set(AMD_APP_SDK_TGZ "${TS_SRCDIR}/AMD-APP-SDK-v3.0.130.135-GA-linux64.sh")
  set(TS_ROOT "${TS_BASEDIR}/src/${TS_NAME}")

  if(EXISTS "${AMD_APP_SDK_TGZ}")

    message(STATUS "Enabling testsuite ${TS_NAME}")
    list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
    set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

    set(UPSTREAM_CMAKE_ARGS "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
    if(CMAKE_C_COMPILER_LAUNCHER)
      list(APPEND UPSTREAM_CMAKE_ARGS "-DCMAKE_C_COMPILER_LAUNCHER=${CMAKE_C_COMPILER_LAUNCHER}")
    endif()
    if(CMAKE_CXX_COMPILER_LAUNCHER)
      list(APPEND UPSTREAM_CMAKE_ARGS "-DCMAKE_CXX_COMPILER_LAUNCHER=${CMAKE_CXX_COMPILER_LAUNCHER}")
    endif()

    ExternalProject_Add(
      ${TS_NAME}
      PREFIX "${TS_BASEDIR}"

      SOURCE_DIR "${TS_ROOT}"
      SOURCE_SUBDIR "AMD-APP-SDK-3.0/samples"

      DOWNLOAD_COMMAND /bin/true
      UPDATE_COMMAND /bin/true

      PATCH_COMMAND /bin/sh "${AMD_APP_SDK_TGZ}" --noexec --keep --target AMD-APP-SDK-3.0 &&
             patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/amdsdk3_0.patch &&
             /bin/sh -c "rm ${TS_ROOT}/AMD-APP-SDK-3.0/lib/x86_64/libOpenCL*"

      CMAKE_ARGS ${UPSTREAM_CMAKE_ARGS}
        "-DCMAKE_CXX_FLAGS_DEBUG=-O0 -ggdb -Wno-deprecated-declarations -Wno-narrowing"
        "-DCMAKE_CXX_FLAGS_RELEASE=-O2 -DNDEBUG -Wno-deprecated-declarations -Wno-narrowing"
        "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -ggdb -Wno-deprecated-declarations -Wno-narrowing"
        -DBUILD_OPENCL=ON -DBUILD_OPENCV=OFF -DBUILD_BOLT=OFF -DBUILD_AMP=OFF
        INSTALL_COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/install.sh "${TS_ROOT}" "${CMAKE_BUILD_TYPE}"
    )

    set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
    add_dependencies(prepare_examples ${TS_NAME})

    set(AMD_SAMPLES
    AdvancedConvolution
    BasicDebug
    BinomialOption
    BinomialOptionMultiGPU
    BitonicSort
    BlackScholes
    BlackScholesDP
    BoxFilter
    BuiltInScan
    ConcurrentKernel
    DCT
    DeviceFission
    DeviceFission11Ext
    DwtHaar1D
    FastWalshTransform
    FloydWarshall
    FluidSimulation2D
    GaussianNoise
    HDRToneMapping
    HelloWorld
    Histogram
    HistogramAtomics
    ImageBinarization
    ImageOverlap
    KernelLaunch
    LUDecomposition
    Mandelbrot
    MatrixMulImage
    MatrixMultiplication
    MatrixTranspose
    MemoryModel
    MonteCarloAsian
    MonteCarloAsianMultiGPU
    NBody
    PrefixSum
    QuasiRandomSequence
    RadixSort
    RecursiveGaussian
    Reduction
    ScanLargeArrays
    SimpleConvolution
    SimpleImage
    SimpleMultiDevice
    SobelFilter
    StringSearch
    Template
    UnsharpMask
    URNG)

    # freeze (requires async queue): FineGrainSVM
    # disabled c++ tests: DwtHaar1DCPPKernel EigenValue
    #     IntroStaticCPPKernel FFT MatrixMultiplicationCPPKernel
    #     MersenneTwister SoAversusAoS TransferOverlapCPP
    # disabled but fixable: BuiltInScan CalcPie CplusplusWrapper
    #     GaussianNoise HDRToneMapping
    #     HeatPDE ImageBandwidth KernelLaunch MatrixMulDouble
    #     MonteCarloAsianDP SobelFilterImage UnsharpMask DynamicOpenCLDetection
    #     FineGrainSVMCAS RecursiveGaussian_ProgramScope SobelFilterImage
    #     SVMAtomicsBinaryTreeInsert SVMBinaryTreeSearch
    # disabled tests: AsyncDataTransfer AtomicCounters BasicDebug
    #     DeviceFission11Ext RangeMinimumQuery SimpleDepthImage
    #     SimpleGenericAddressSpace
    # disabled graphics tests: KmeansAutoclustering
    #     GaussianNoiseGL SimpleGL BoxFilterGL URNGNoiseGL
    # very slow: BufferBandwidth LDSBandwidth ConstantBandwidth
    #     MemoryOptimizations TransferOverlap
    # disabled - requires dev queue: BinarySearchDeviceSideEnqueue
    #     DeviceEnqueueBFS ExtractPrimes GlobalMemoryBandwidth
    #     RegionGrowingSegmentation SimpleSPIR
    # disabled - requires pipe: PipeProducerConsumerKernels SimplePipe
    # requires OpenCL 2.0: BufferImageInterop

    set(HSA_LABELED_TESTS
        AMD_30_BinomialOption AMD_30_DCT AMD_30_BlackScholes
        AMD_30_FastWalshTransform AMD_30_FloydWarshall AMD_30_HelloWorld
        AMD_30_Histogram AMD_30_MatrixMultiplication AMD_30_MatrixTranspose
        AMD_30_PrefixSum AMD_30_QuasiRandomSequence AMD_30_ScanLargeArrays
        AMD_30_SimpleConvolution AMD_30_URNG)

    if(ENABLE_HSA)
      list(APPEND AMD_SAMPLES CalcPie)
      list(APPEND HSA_LABELED_TESTS AMD_30_CalcPie)
    endif()

    foreach(SAMPLE IN LISTS AMD_SAMPLES)
      add_test(NAME "AMD_30_${SAMPLE}"
        COMMAND "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-3.0/samples/opencl/bin/x86_64/${SAMPLE}" "-q" "-t" "-e"
        WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/AMD-APP-SDK-3.0/samples/opencl/bin/x86_64")
      set_tests_properties("AMD_30_${SAMPLE}" PROPERTIES LABELS "amdsdk_30")
    endforeach()

    # AMD_30_HeatPDE
    # AMD_30_FineGrainSVMCAS
    set_tests_properties(
      ${HSA_LABELED_TESTS}
      PROPERTIES
        LABELS "hsa")

    # XFAILs as of 2016-05-17:
    # AMD_30_BuiltInScan: undefined symbol: work_group_scan_inclusive_add
    # AMD_30_GaussianNoise, AMD_30_HDRToneMapping: Invalid platform.
    # AMD_30_ImageBinarization: work_group_barrier missing
    # AMD_30_HDRToneMapping: no output
    # AMD_30_UnsharpMask: clCreateContextFromType failed
    set_tests_properties(AMD_30_BuiltInScan
      AMD_30_GaussianNoise AMD_30_HDRToneMapping
      AMD_30_ImageBinarization AMD_30_KernelLaunch
      AMD_30_UnsharpMask
      PROPERTIES  WILL_FAIL 1)

  else()
    message(STATUS "Disabling testsuite ${TS_NAME} - tarball not found")
  endif()

else()
  message(STATUS "AMD APP SDK testsuite is only enabled for x86_64 Linux systems currently")
endif()

=== examples/EinsteinToolkit/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

#AM_CPPFLAGS = -I$(top_srcdir)/fix-include -I$(top_srcdir)/include -DSRCDIR='"$(abs_srcdir)"'
add_definitions("-DSRCDIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")

# EinsteinToolkit_CFLAGS = @OPENCL_CFLAGS@
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 ${OPENCL_CFLAGS}")
add_compile_options(${OPENCL_CFLAGS} -std=c99)

if (MSVC)
  set_source_files_properties( EinsteinToolkit.c PROPERTIES LANGUAGE CXX )
endif(MSVC)
add_executable("EinsteinToolkit" EinsteinToolkit.c ML_BSSN_CL_RHS1.cl ML_BSSN_CL_RHS2.cl)

# EinsteinToolkit_LDADD = @OPENCL_LIBS@ ../../lib/poclu/libpoclu.la
target_link_libraries("EinsteinToolkit" ${POCLU_LINK_OPTIONS})

if(NOT MIPS)
  add_test(NAME "EinsteinToolkit" COMMAND "EinsteinToolkit")

  set_tests_properties( "EinsteinToolkit"
    PROPERTIES
    COST 15.0
    LABELS "internal;EinsteinToolkit"
    DEPENDS "pocl_version_check")

  add_test(NAME "EinsteinToolkit_SubDev" COMMAND "EinsteinToolkit" s)

  set_tests_properties( "EinsteinToolkit_SubDev"
    PROPERTIES
    COST 15.0
    LABELS "EinsteinToolkit"
    ENVIRONMENT "POCL_AFFINITY=1"
    SKIP_RETURN_CODE 77
    DEPENDS "pocl_version_check")
endif()

=== examples/Halide/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME Halide)
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

# Halide disabled for now, need to find out which tests actually use OpenCL
if(0)

message(STATUS "Enabling testsuite ${TS_NAME}")
list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE GIT_REPOSITORY "https://github.com/Halide/Halide.git")
else()
  set(FETCH_SOURCE URL "https://github.com/halide/Halide/archive/release_2017_10_30.tar.gz")
endif()

ExternalProject_Add(
  ${TS_NAME}
  PREFIX "${TS_BASEDIR}"
  ${FETCH_SOURCE}
  #PATCH_COMMAND /bin/sh "${AMD_APP_SDK_TGZ}" --noexec --keep --target AMD-APP-SDK-3.0 &&
  #     patch -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/amdsdk3_0.patch
  CMAKE_ARGS
    -DCMAKE_BUILD_TYPE=RelWithDebInfo
    -DTARGET_ARM=OFF
    -DTARGET_AARCH64=OFF
    -DTARGET_MIPS=OFF
    -DTARGET_METAL=OFF
    -DTARGET_OPENCL=ON
    -DTARGET_OPENGL=OFF
    -DTARGET_OPENGLCOMPUTE=OFF
    -DTARGET_PTX=OFF
    -DTARGET_X86=ON
  CMAKE_CACHE_ARGS
    "-DLLVM_BIN:STRING=${LLVM_BINDIR}"
    "-DLLVM_LIB:STRING=${LLVM_LIBDIR}"
    "-DLLVM_INCLUDE:STRING=${LLVM_INCLUDEDIR}"
    "-DLLVM_VERSION:STRING=${LLVM_MAJOR}${LLVM_MINOR}"
  INSTALL_COMMAND "/bin/true"
)

set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
add_dependencies(prepare_examples ${TS_NAME})

# TODO Probably not tests
# acquire_release.generator argvcall.generator cleanup_on_error.generator
# embed_image.generator example.generator extended_buffer_t.generator
# error_codes.generator gpu_object_lifetime.generator gpu_only.generator
# mandelbrot.generator matlab.generator metadata_tester.generator
# nested_externs.generator paramtest.generator pyramid.generator
# runtime.generator tiled_blur.generator tiled_blur_blur.generator
# user_context.generator user_context_insanity.generator

add_test(NAME halide_bilateral_grid
         COMMAND "${TS_BUILDDIR}/bin/bilateral_grid")
add_test(NAME halide_bitcode2cpp
         COMMAND "${TS_BUILDDIR}/bin/bitcode2cpp")
add_test(NAME halide_blur_test
         COMMAND "${TS_BUILDDIR}/bin/blur_test")
add_test(NAME halide_build_halide_h
         COMMAND "${TS_BUILDDIR}/bin/build_halide_h")
add_test(NAME halide_camera_pipe
         COMMAND "${TS_BUILDDIR}/bin/camera_pipe")
add_test(NAME halide_correctness_argmax
         COMMAND "${TS_BUILDDIR}/bin/correctness_argmax")
add_test(NAME halide_correctness_assertion_failure_in_parallel_for
         COMMAND "${TS_BUILDDIR}/bin/correctness_assertion_failure_in_parallel_for")
add_test(NAME halide_correctness_autotune_bug
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug")
add_test(NAME halide_correctness_autotune_bug_2
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_2")
add_test(NAME halide_correctness_autotune_bug_3
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_3")
add_test(NAME halide_correctness_autotune_bug_4
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_4")
add_test(NAME halide_correctness_autotune_bug_5
         COMMAND "${TS_BUILDDIR}/bin/correctness_autotune_bug_5")
add_test(NAME halide_correctness_bad_likely
         COMMAND "${TS_BUILDDIR}/bin/correctness_bad_likely")
add_test(NAME halide_correctness_bit_counting
         COMMAND "${TS_BUILDDIR}/bin/correctness_bit_counting")
add_test(NAME halide_correctness_bitwise_ops
         COMMAND "${TS_BUILDDIR}/bin/correctness_bitwise_ops")
add_test(NAME halide_correctness_bool_compute_root_vectorize
         COMMAND "${TS_BUILDDIR}/bin/correctness_bool_compute_root_vectorize")
add_test(NAME halide_correctness_bound
         COMMAND "${TS_BUILDDIR}/bin/correctness_bound")
add_test(NAME halide_correctness_boundary_conditions
         COMMAND "${TS_BUILDDIR}/bin/correctness_boundary_conditions")
add_test(NAME halide_correctness_bounds
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds")
add_test(NAME halide_correctness_bounds_inference
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference")
add_test(NAME halide_correctness_bounds_inference_chunk
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference_chunk")
add_test(NAME halide_correctness_bounds_inference_complex
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_inference_complex")
add_test(NAME halide_correctness_bounds_of_abs
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_abs")
add_test(NAME halide_correctness_bounds_of_cast
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_cast")
add_test(NAME halide_correctness_bounds_of_func
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_func")
add_test(NAME halide_correctness_bounds_of_monotonic_math
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_of_monotonic_math")
add_test(NAME halide_correctness_bounds_query
         COMMAND "${TS_BUILDDIR}/bin/correctness_bounds_query")
add_test(NAME halide_correctness_buffer_t
         COMMAND "${TS_BUILDDIR}/bin/correctness_buffer_t")
add_test(NAME halide_correctness_cascaded_filters
         COMMAND "${TS_BUILDDIR}/bin/correctness_cascaded_filters")
add_test(NAME halide_correctness_cast
         COMMAND "${TS_BUILDDIR}/bin/correctness_cast")
add_test(NAME halide_correctness_cast_handle
         COMMAND "${TS_BUILDDIR}/bin/correctness_cast_handle")
add_test(NAME halide_correctness_c_function
         COMMAND "${TS_BUILDDIR}/bin/correctness_c_function")
add_test(NAME halide_correctness_chunk
         COMMAND "${TS_BUILDDIR}/bin/correctness_chunk")
add_test(NAME halide_correctness_chunk_sharing
         COMMAND "${TS_BUILDDIR}/bin/correctness_chunk_sharing")
add_test(NAME halide_correctness_circular_reference_leak
         COMMAND "${TS_BUILDDIR}/bin/correctness_circular_reference_leak")
add_test(NAME halide_correctness_code_explosion
         COMMAND "${TS_BUILDDIR}/bin/correctness_code_explosion")
add_test(NAME halide_correctness_compare_vars
         COMMAND "${TS_BUILDDIR}/bin/correctness_compare_vars")
add_test(NAME halide_correctness_compile_to
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to")
add_test(NAME halide_correctness_compile_to_bitcode
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to_bitcode")
add_test(NAME halide_correctness_compile_to_lowered_stmt
         COMMAND "${TS_BUILDDIR}/bin/correctness_compile_to_lowered_stmt")
add_test(NAME halide_correctness_compute_at_split_rvar
         COMMAND "${TS_BUILDDIR}/bin/correctness_compute_at_split_rvar")
add_test(NAME halide_correctness_computed_index
         COMMAND "${TS_BUILDDIR}/bin/correctness_computed_index")
add_test(NAME halide_correctness_compute_outermost
         COMMAND "${TS_BUILDDIR}/bin/correctness_compute_outermost")
add_test(NAME halide_correctness_constant_expr
         COMMAND "${TS_BUILDDIR}/bin/correctness_constant_expr")
add_test(NAME halide_correctness_constant_type
         COMMAND "${TS_BUILDDIR}/bin/correctness_constant_type")
add_test(NAME halide_correctness_constraints
         COMMAND "${TS_BUILDDIR}/bin/correctness_constraints")
add_test(NAME halide_correctness_convolution
         COMMAND "${TS_BUILDDIR}/bin/correctness_convolution")
add_test(NAME halide_correctness_convolution_multiple_kernels
         COMMAND "${TS_BUILDDIR}/bin/correctness_convolution_multiple_kernels")
add_test(NAME halide_correctness_cross_compilation
         COMMAND "${TS_BUILDDIR}/bin/correctness_cross_compilation")
add_test(NAME halide_correctness_custom_allocator
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_allocator")
add_test(NAME halide_correctness_custom_error_reporter
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_error_reporter")
add_test(NAME halide_correctness_custom_lowering_pass
         COMMAND "${TS_BUILDDIR}/bin/correctness_custom_lowering_pass")
add_test(NAME halide_correctness_debug_to_file
         COMMAND "${TS_BUILDDIR}/bin/correctness_debug_to_file")
add_test(NAME halide_correctness_deinterleave4
         COMMAND "${TS_BUILDDIR}/bin/correctness_deinterleave4")
add_test(NAME halide_correctness_div_mod
         COMMAND "${TS_BUILDDIR}/bin/correctness_div_mod")
add_test(NAME halide_correctness_dynamic_reduction_bounds
         COMMAND "${TS_BUILDDIR}/bin/correctness_dynamic_reduction_bounds")
add_test(NAME halide_correctness_erf
         COMMAND "${TS_BUILDDIR}/bin/correctness_erf")
add_test(NAME halide_correctness_exception
         COMMAND "${TS_BUILDDIR}/bin/correctness_exception")
add_test(NAME halide_correctness_explicit_inline_reductions
         COMMAND "${TS_BUILDDIR}/bin/correctness_explicit_inline_reductions")
add_test(NAME halide_correctness_extern_bounds_inference
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_bounds_inference")
add_test(NAME halide_correctness_extern_consumer
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_consumer")
add_test(NAME halide_correctness_extern_error
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_error")
add_test(NAME halide_correctness_extern_output_expansion
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_output_expansion")
add_test(NAME halide_correctness_extern_producer
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_producer")
add_test(NAME halide_correctness_extern_sort
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_sort")
add_test(NAME halide_correctness_extern_stage
         COMMAND "${TS_BUILDDIR}/bin/correctness_extern_stage")
add_test(NAME halide_correctness_fibonacci
         COMMAND "${TS_BUILDDIR}/bin/correctness_fibonacci")
add_test(NAME halide_correctness_float16_t_comparison
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_comparison")
add_test(NAME halide_correctness_float16_t_constants
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_constants")
add_test(NAME halide_correctness_float16_t_image_type
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_image_type")
add_test(NAME halide_correctness_float16_t_implicit_upcast
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_implicit_upcast")
add_test(NAME halide_correctness_float16_t_realize_constant
         COMMAND "${TS_BUILDDIR}/bin/correctness_float16_t_realize_constant")
add_test(NAME halide_correctness_func_lifetime
         COMMAND "${TS_BUILDDIR}/bin/correctness_func_lifetime")
add_test(NAME halide_correctness_func_lifetime_2
         COMMAND "${TS_BUILDDIR}/bin/correctness_func_lifetime_2")
add_test(NAME halide_correctness_fuse
         COMMAND "${TS_BUILDDIR}/bin/correctness_fuse")
add_test(NAME halide_correctness_fused_where_inner_extent_is_zero

=== examples/IntelSVM/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME IntelSVM)
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
set(INTEL_ZIP "${TS_SRCDIR}/intel_ocl_svm_basic_win.zip")

if (EXISTS "${INTEL_ZIP}")
  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    DOWNLOAD_COMMAND /bin/true
    PATCH_COMMAND pwd && unzip "${INTEL_ZIP}" &&
      cp "${CMAKE_CURRENT_SOURCE_DIR}/intelsvm_CMakeLists.txt" ./CMakeLists.txt &&
      patch -p0 -d SVMBasicCoarseGrained -i ${CMAKE_CURRENT_SOURCE_DIR}/intelsvm.patch &&
      patch -p0 -d SVMBasicFineGrained -i ${CMAKE_CURRENT_SOURCE_DIR}/intelsvm.patch
    CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO=-O2 -g -DCL_USE_DEPRECATED_OPENCL_1_2_APIS"
      -DOPENCL_LIBRARIES:STRING=OpenCL
      "-DPOCL_OPENCL_HEADERS=${CMAKE_SOURCE_DIR}/include"
    INSTALL_COMMAND "/bin/true"
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME intel_svm_coarse
    COMMAND "${TS_BUILDDIR}/coarse" -p 0 -t default
    WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/SVMBasicCoarseGrained")
  add_test(NAME intel_svm_fine
    COMMAND "${TS_BUILDDIR}/fine" -p 0 -t default
    WORKING_DIRECTORY "${TS_BASEDIR}/src/${TS_NAME}/SVMBasicFineGrained")

  set_tests_properties(intel_svm_coarse intel_svm_fine
    PROPERTIES  LABELS "IntelSVM;hsa")
  set_tests_properties(intel_svm_coarse intel_svm_fine
    PROPERTIES  PASS_REGULAR_EXPRESSION "PASSED")

else()

  message(STATUS "Disabling testsuite ${TS_NAME}, required files not found" )

endif()

=== examples/OpenCV/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "OpenCV")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")

set(OPENCV "opencv-3.4.1")
set(OPENCV_ZIP "${TS_SRCDIR}/${OPENCV}.zip")

if(EXISTS "${OPENCV_ZIP}")

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    # Download URL is "https://github.com/Itseez/opencv/archive/${OPENCV_ZIP}"
    # but for some reason it doesn't work from cmake.
    DOWNLOAD_COMMAND pwd && unzip "${OPENCV_ZIP}"
      && rmdir OpenCV && mv ${OPENCV} OpenCV

    # TODO this should be optimized to only build
    # the stuff required for testing OpenCL
    CMAKE_ARGS -DCMAKE_BUILD_TYPE=RelWithDebInfo
      -DWITH_CUDA=OFF
      -DWITH_OPENCL=ON
      -DWITH_FFMPEG=OFF
      -DBUILD_TESTS=ON
      -DBUILD_PERF_TESTS=ON
      -DBUILD_EXAMPLES=ON
      -DBUILD_DOCS=OFF
      -DWITH_IPP=OFF
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME test_UMat
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat.*")

  add_test(NAME test_Core_UMat
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=Core_UMat.*")

  add_test(NAME test_Image2D
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=Image2D.*")

  add_test(NAME test_UMat_UMatBasicTests
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat/UMatBasicTests.*")

  add_test(NAME test_UMat_UMatTestReshape
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat/UMatTestReshape.*")

  add_test(NAME test_UMat_UMatTestRoi
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat/UMatTestRoi.*")

  add_test(NAME test_UMat_UMatTestSizeOperations
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat/UMatTestSizeOperations.*")

  add_test(NAME test_UMat_UMatTestUMatOperations
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=UMat/UMatTestUMatOperations.*")

  add_test(NAME test_OCL_MeanStdDev_
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_MeanStdDev_.*")

  add_test(NAME test_OCL_Channels_Merge
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Channels/Merge.*")

  add_test(NAME test_OCL_Channels_Split
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Channels/Split.*")

  add_test(NAME test_OCL_Channels_MixChannels
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Channels/MixChannels.*")

  add_test(NAME test_OCL_Channels_InsertChannels
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Channels/InsertChannels.*")

  add_test(NAME test_OCL_Channels_ExtractChannels
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Channels/ExtractChannels.*")

  add_test(NAME test_OCL_Arithm_Lut
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Lut.*")

  add_test(NAME test_OCL_Arithm_Add
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Add.*")

  add_test(NAME test_OCL_Arithm_Subtract
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Substract.*")

  add_test(NAME test_OCL_Arithm_Mul
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Mul.*")

  add_test(NAME test_OCL_Arithm_Div
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Div.*")

  add_test(NAME test_OCL_Arithm_AddWeighted
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/AddWeighted.*")

  add_test(NAME test_OCL_Arithm_Min
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Min.*")

  add_test(NAME test_OCL_Arithm_Max
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Max.*")

  add_test(NAME test_OCL_Arithm_Absdiff
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Absdiff.*")

  add_test(NAME test_OCL_Arithm_CartToPolar
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/CartToPolar.*")

  add_test(NAME test_OCL_Arithm_PolarToCart
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/PolarToCart.*")

  add_test(NAME test_OCL_Arithm_Transpose
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Transpose.*")

  add_test(NAME test_OCL_Arithm_Bitwise_and
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/BitWise_and.*")

  add_test(NAME test_OCL_Arithm_Bitwise_or
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Bitwise_or.*")

  add_test(NAME test_OCL_Arithm_Bitwise_xor
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Bitwise_xor.*")

  add_test(NAME test_OCL_Arithm_Bitwise_not
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Bitwise_not.*")

  add_test(NAME test_OCL_Arithm_Compare
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Compare.*")

  add_test(NAME test_OCL_Arithm_Pow
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Pow.*")

  add_test(NAME test_OCL_Arithm_SetIdentity
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/SetIdentity.*")

  add_test(NAME test_OCL_Arithm_Repeat
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Repeat.*")

  add_test(NAME test_OCL_Arithm_CountNonZero
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/CountNonZero.*")

  add_test(NAME test_OCL_Arithm_Sum
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Sum.*")

  add_test(NAME test_OCL_Arithm_MeanStdDev
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/MeanStdDev.*")

  add_test(NAME test_OCL_Arithm_Log
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Log.*")

  add_test(NAME test_OCL_Arithm_Exp
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Exp.*")

  add_test(NAME test_OCL_Arithm_Phase
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Phase.*")

  add_test(NAME test_OCL_Arithm_Magnitude
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Magnitude.*")

  add_test(NAME test_OCL_Arithm_Flip
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Flip.*")

  add_test(NAME test_OCL_Arithm_MinMaxIdx
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/MinMaxIdx.*")

  add_test(NAME test_OCL_Arithm_MinMaxIdx_Mask
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/MinMaxIdx_Mask.*")

  add_test(NAME test_OCL_Arithm_Norm
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Norm.*")

  add_test(NAME test_OCL_Arithm_UMatDot
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/UMatDot.*")

  add_test(NAME test_OCL_Arithm_Sqrt
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Sqrt.*")

  add_test(NAME test_OCL_Arithm_Normalize
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Normalize.*")

  add_test(NAME test_OCL_Arithm_InRange
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/InRange.*")

  add_test(NAME test_OCL_Arithm_ConvertScaleAbs
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ConvertScaleAbs.*")

  add_test(NAME test_OCL_Arithm_ScaleAdd
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ScaleAdd.*")

  add_test(NAME test_OCL_Arithm_PatchNaNs
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/PatchNaNs.*")

  add_test(NAME test_OCL_Arithm_Psnr
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/Psnr.*")

  add_test(NAME test_OCL_Arithm_ReduceSum
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ReduceSum.*")

  add_test(NAME test_OCL_Arithm_ReduceMax
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ReduceMax.*")

  add_test(NAME test_OCL_Arithm_ReduceMin
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ReduceMin.*")

  add_test(NAME test_OCL_Arithm_ReduceAvg
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Arithm/ReduceAvg.*")

  add_test(NAME test_OCL_Core_Gemm
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Core/Gemm.*")

  add_test(NAME test_OCL_Core_Dft
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_Core/Dft.*")

  add_test(NAME test_OCL_OCL_ImgProc_MultiSpectrums
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_OCL_ImgProc/MultiSpectrums.*")

  add_test(NAME test_OCL_MatrixOperation_ConvertTo
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_MatrixOperation/ConvertTo.*")

  add_test(NAME test_OCL_MatrixOperation_CopyTo
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_MatrixOperation/CopyTo.*")

  add_test(NAME test_OCL_MatrixOperation_SetTo
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_MatrixOperation/SetTo.*")

  add_test(NAME test_OCL_MatrixOperation_UMatExpr
     COMMAND "${TS_BUILDDIR}/bin/opencv_test_core" "--gtest_filter=OCL_MatrixOperation/UMatExpr.*")

  set_tests_properties(
    test_UMat
    test_Core_UMat
    test_Image2D
    test_UMat_UMatBasicTests
    test_UMat_UMatTestReshape
    test_UMat_UMatTestRoi
    test_UMat_UMatTestSizeOperations
    test_UMat_UMatTestUMatOperations
    test_OCL_MeanStdDev_
    test_OCL_Channels_Merge
    test_OCL_Channels_Split
    test_OCL_Channels_MixChannels
    test_OCL_Channels_InsertChannels
    test_OCL_Channels_ExtractChannels
    test_OCL_Arithm_Lut
    test_OCL_Arithm_Add
    test_OCL_Arithm_Subtract
    test_OCL_Arithm_Mul
    test_OCL_Arithm_Div
    test_OCL_Arithm_AddWeighted
    test_OCL_Arithm_Min
    test_OCL_Arithm_Max
    test_OCL_Arithm_Absdiff
    test_OCL_Arithm_CartToPolar
    test_OCL_Arithm_PolarToCart
    test_OCL_Arithm_Transpose
    test_OCL_Arithm_Bitwise_and
    test_OCL_Arithm_Bitwise_or
    test_OCL_Arithm_Bitwise_xor
    test_OCL_Arithm_Bitwise_not
    test_OCL_Arithm_Compare

=== examples/ViennaCL/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2015 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(TS_NAME "ViennaCL")
set(TS_BASEDIR "${TESTSUITE_BASEDIR}/${TS_NAME}")
set(TS_BUILDDIR "${TS_BASEDIR}/src/${TS_NAME}-build")
set(TS_SRCDIR "${TESTSUITE_SOURCE_BASEDIR}/${TS_NAME}")
set(VIENNA "ViennaCL-1.7.1")
set(ViennaCL_TGZ "${TS_SRCDIR}/${VIENNA}.tar.gz")

if(EXAMPLES_USE_GIT_MASTER)
  set(FETCH_SOURCE GIT_REPOSITORY "https://github.com/viennacl/viennacl-dev.git")
else()
  set(FETCH_SOURCE URL "https://sourceforge.net/projects/viennacl/files/1.7.x/ViennaCL-1.7.1.tar.gz/download")
endif()

if(EXISTS "${ViennaCL_TGZ}")

  message(STATUS "Enabling testsuite ${TS_NAME}")
  list(APPEND ACTUALLY_ENABLED_TESTSUITES "${TS_NAME}")
  set(ACTUALLY_ENABLED_TESTSUITES ${ACTUALLY_ENABLED_TESTSUITES} PARENT_SCOPE)

  ExternalProject_Add(
    ${TS_NAME}
    PREFIX "${TS_BASEDIR}"
    SOURCE_DIR "${TS_BASEDIR}/src/${VIENNA}"
    DOWNLOAD_COMMAND
      test -d "${TS_BASEDIR}/src/${VIENNA}/ViennaCLConfig.cmake" || tar xzf "${ViennaCL_TGZ}"
    PATCH_COMMAND patch -N -r- -p1 -i
      ${CMAKE_CURRENT_SOURCE_DIR}/vienna_170.patch || /bin/true
    UPDATE_COMMAND /bin/true
    CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=RelWithDebInfo
      -DBUILD_TESTING:BOOL=ON
      -DBUILD_EXAMPLES:BOOL=ON
      -DENABLE_OPENCL:BOOL=ON
      -DENABLE_CUDA:BOOL=OFF
      -DENABLE_UBLAS:BOOL=OFF
      "-DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING=-g -O0 -DCL_USE_DEPRECATED_OPENCL_1_1_APIS"
    INSTALL_COMMAND /bin/true
  )

  set_target_properties(${TS_NAME} PROPERTIES EXCLUDE_FROM_ALL TRUE)
  add_dependencies(prepare_examples ${TS_NAME})

  add_test(NAME viennacl_examples_amg
          COMMAND "${TS_BUILDDIR}/examples/tutorial/amg"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_examples_bandwidth_reduction
#          COMMAND "${TS_BUILDDIR}/examples/tutorial/bandwidth-reduction"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_custom_kernels
          COMMAND "${TS_BUILDDIR}/examples/tutorial/custom-kernels"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_blas1
          COMMAND "${TS_BUILDDIR}/examples/tutorial/blas1"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_custom_context
          COMMAND "${TS_BUILDDIR}/examples/tutorial/custom-context"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_bisect
          COMMAND "${TS_BUILDDIR}/examples/tutorial/bisect"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_fft
          COMMAND "${TS_BUILDDIR}/examples/tutorial/fft"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_iterative_custom
          COMMAND "${TS_BUILDDIR}/examples/tutorial/iterative-custom"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_matrix_free
          COMMAND "${TS_BUILDDIR}/examples/tutorial/matrix-free"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_nmf
          COMMAND "${TS_BUILDDIR}/examples/tutorial/nmf"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_viennacl_info
          COMMAND "${TS_BUILDDIR}/examples/tutorial/viennacl-info"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_wrap_host_buffer
          COMMAND "${TS_BUILDDIR}/examples/tutorial/wrap-host-buffer"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_scheduler
          COMMAND "${TS_BUILDDIR}/examples/tutorial/scheduler"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_examples_libviennacl_tutorial
          COMMAND "${TS_BUILDDIR}/examples/tutorial/libviennacl-tutorial"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")

#  add_test(NAME viennacl_benchmarks_opencl_bench_opencl
#          COMMAND "${TS_BUILDDIR}/examples/benchmarks/opencl-bench-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_benchmarks_dense_blas_bench_opencl
#          COMMAND "${TS_BUILDDIR}/examples/benchmarks/dense_blas-bench-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")

#  add_test(NAME viennacl_tests_bisect_test_opencl
#          COMMAND "${TS_BUILDDIR}/tests/bisect-test-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_fft_1d_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/fft_1d-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_external_linkage_opencl
          COMMAND "${TS_BUILDDIR}/tests/external_linkage-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_blas3_solve_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/blas3_solve-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_fft_2d_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/fft_2d-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas1_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas1-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_iterators_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/iterators-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_global_variables_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/global_variables-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas2_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas2-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_libviennacl_blas3_test
          COMMAND "${TS_BUILDDIR}/tests/libviennacl_blas3-test"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_col_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_col_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_product_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_product_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_convert_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_convert-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_product_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_product_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_float_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_float-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_row_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_row_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_vector_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_vector-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_nmf_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/nmf-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_scalar_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/scalar-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_matrix_vector_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/matrix_vector_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_qr_method_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/qr_method-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_qr_method_func_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/qr_method_func-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_scan_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/scan-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_self_assign_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/self_assign-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_sparse_prod_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/sparse_prod-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_sparse_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/sparse-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_structured_matrices_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/structured-matrices-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_spmdm_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/spmdm-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
#  add_test(NAME viennacl_tests_svd_test_opencl
#          COMMAND "${TS_BUILDDIR}/tests/svd-test-opencl"
#          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_tql_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/tql-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_convert_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_convert-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_float_double_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_float_double-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_multi_inner_prod_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_multi_inner_prod-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_int_test_opencl
          COMMAND "${TS_BUILDDIR}/tests/vector_int-test-opencl"
          WORKING_DIRECTORY "${TS_BUILDDIR}/tests")
  add_test(NAME viennacl_tests_vector_uint_test_opencl

=== examples/accel/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2019 Pekka Jääskeläinen
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

set(PROGRAMS_TO_BUILD accel_example)

if (MSVC)
  add_compile_options(${OPENCL_CFLAGS})
else ()
  add_compile_options("-std=c++11" "-Wno-deprecated" "-Wno-deprecated-declarations" ${OPENCL_CFLAGS})
endif ()

add_definitions("-DSRCDIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")
include_directories("${CMAKE_SOURCE_DIR}/lib/CL" ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_CXX_STANDARD 14)
foreach(PROG ${PROGRAMS_TO_BUILD})
  add_executable("${PROG}" "${PROG}.cpp")
  target_link_libraries("${PROG}" ${POCLU_LINK_OPTIONS})
endforeach()

# this test requires 2 devices
add_executable(accel_countred accel_countred.cpp OpenCLcontext.cpp  OpenCLcontext.h)
target_link_libraries(accel_countred ${POCLU_LINK_OPTIONS})


add_custom_target(bitstreams)

find_program(VIVADO vivado
    HINTS ${VIVADO_PATH})
if(VIVADO)
    MESSAGE(STATUS "Vivado: ${VIVADO}")
else()
    MESSAGE(STATUS "No vivado found: given vivado path was:${VIVADO_PATH}")
endif()

find_program(VITIS_HLS vitis_hls
    HINTS ${VITIS_HLS_PATH})
if(VITIS_HLS)
    MESSAGE(STATUS "Vitis HLS: ${VITIS_HLS}")
endif()

find_program(PYNQ_AVAILABLE pynq)
if(PYNQ_AVAILABLE)
    MESSAGE(STATUS "Pynq installation found")
endif ()


  #add_subdirectory(gen_accel)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bitstreams)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/firmware_imgs)



  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/axim_sep.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/axim_fused_global_private.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/axim_fused_global_cq.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/axim_fused_global_cq_private.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)

  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/relative_sep.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/relative_fused_global_private.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/relative_fused_global_cq.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)
  configure_file(${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/relative_fused_global_cq_private.adf ${CMAKE_CURRENT_BINARY_DIR}/firmwares)

  configure_file(firmware.c ${CMAKE_CURRENT_BINARY_DIR})
  configure_file(run_standalone_ttasim.sh ${CMAKE_CURRENT_BINARY_DIR} @ONLY)
  configure_file(run_standalone_rtlsim.sh ${CMAKE_CURRENT_BINARY_DIR} @ONLY)

  function(generate_firmware core_name base_address queue_length queue_start init_sp data_start use_axim tta_device_hash)

    if(ENABLE_TCE)
    set(ADF ${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/${core_name}.adf)
    set(TPEF ${CMAKE_CURRENT_BINARY_DIR}/firmwares/${core_name}.tpef)

    message("ADF=${ADF}")

    set(PARAMS "")
    if(NOT base_address STREQUAL "")
      list(APPEND PARAMS "-DBASE_ADDRESS=${base_address}")
    endif()
    if(NOT queue_length STREQUAL "")
      list(APPEND PARAMS "-DQUEUE_LENGTH=${queue_length}")
    endif()
    if(NOT queue_start STREQUAL "")
      list(APPEND PARAMS "-DQUEUE_START=${queue_start}")
    endif()
    if(NOT init_sp STREQUAL "")
      list(APPEND PARAMS "--init-sp=${init_sp}")
      list(APPEND PARAMS "--data-start=${data_start}")
    endif()
    add_custom_command(OUTPUT firmwares/${core_name}.tpef
      COMMAND tcecc -o3 ${PARAMS} -g -a ${ADF} -o ${TPEF} firmware.c
      COMMAND generatebits -e tta_core -f bin2n -p ${TPEF} ${ADF}
      COMMAND tcedisasm -n ${ADF} ${TPEF}
      COMMAND mv ${core_name}.img ${CMAKE_CURRENT_BINARY_DIR}/firmware_imgs/
      DEPENDS ${ADF} ${CMAKE_CURRENT_SOURCE_DIR}/firmware.c
      COMMENT "Compiling ${core_name} firmware with params ${PARAMS}")
    add_custom_target(${core_name}_firmware ALL DEPENDS firmwares/${core_name}.tpef)
    
    
    add_custom_command(OUTPUT rtls/rtl_${core_name}
      COMMAND rm -rf rtls/rtl_${core_name}
      COMMAND generateprocessor -t --prefer-generation -o rtls/rtl_${core_name} -e tta_core --icd-arg-list=debugger:minimal
      --hdb-list=generate_lsu_32.hdb,generate_rf_iu.hdb,xilinx_series7.hdb,generate_base32.hdb
      -f onchip -d onchip -g AlmaIFIntegrator -p ${TPEF} ${ADF}
      COMMAND generatebits -x rtls/rtl_${core_name} -e tta_core ${ADF}
      DEPENDS ${ADF})
    add_custom_target(${core_name}_rtl ALL DEPENDS rtls/rtl_${core_name})


    add_custom_command(OUTPUT bitstreams/${core_name}.bit
      COMMAND rm -rf vivado_${core_name}_1
      COMMAND ${VIVADO} -mode batch -source ${CMAKE_CURRENT_SOURCE_DIR}/generate_project.tcl
       -tclargs ${core_name} -tclargs 1 -tclargs ${use_axim}
       COMMAND cp vivado_${core_name}_1/vivado_${core_name}_1.runs/impl_1/toplevel_wrapper.bit
        bitstreams/${core_name}.bit
      COMMAND cp vivado_${core_name}_1/vivado_${core_name}_1.gen/sources_1/bd/toplevel/hw_handoff/toplevel.hwh
        bitstreams/${core_name}.hwh
      DEPENDS ${core_name}_rtl ${CMAKE_CURRENT_SOURCE_DIR}/generate_project.tcl)
    add_custom_target(${core_name}_bs DEPENDS bitstreams/${core_name}.bit)

    add_dependencies(bitstreams ${core_name}_bs)

    add_custom_command(OUTPUT ${core_name}_example0.poclbin
        DEPENDS ${CMAKE_SOURCE_DIR}/examples/example0/example0.cl poclcc ${POCL_LIBRARY_NAME} pocl-devices-almaif
        COMMAND
        POCL_BUILDING=1
        OCL_ICD_VENDORS=${CMAKE_BINARY_DIR}/ocl-vendors/
        POCL_DEVICES=almaif
        POCL_ALMAIF0_PARAMETERS=0xB,${CMAKE_SOURCE_DIR}/tools/data/tta_test_machines/${core_name},65535
        POCL_DEBUG=almaif
        ${CMAKE_BINARY_DIR}/bin/poclcc -o ${core_name}_example0.poclbin ${CMAKE_SOURCE_DIR}/examples/example0/example0.cl 2>&1
        | grep "TCE DEVICE HASH"
        | cut -d "=" -f 2
        | cut -d "[" -f 1
        )

    add_custom_target(${core_name}_poclbin ALL DEPENDS ${core_name}_example0.poclbin)
    add_test(NAME "examples/example0/ttasim_poclbin_${core_name}"
        COMMAND "${CMAKE_BINARY_DIR}/examples/example0/example0" "b" "${CMAKE_BINARY_DIR}/examples/accel/${core_name}_example0.poclbin")


    add_test_pocl(NAME "examples/accel/add.i32/ttasim_${core_name}" COMMAND "accel_example" "pocl.add.i32" WORKITEM_HANDLER "loopvec")
    add_test_pocl(NAME "examples/accel/mul.i32/ttasim_${core_name}" COMMAND "accel_example" "pocl.mul.i32" WORKITEM_HANDLER "loopvec")

    #Bit clunky to add test from different directory. However, this file contains the list of different tta configurations
    add_test_pocl(NAME "examples/example0/ttasim_${core_name}" COMMAND "../example0/example0####o" WORKITEM_HANDLER "loopvec")

    set_tests_properties( "examples/accel/add.i32/ttasim_${core_name}" "examples/accel/mul.i32/ttasim_${core_name}"
                          "examples/example0/ttasim_${core_name}" "examples/example0/ttasim_poclbin_${core_name}"
        PROPERTIES
            PASS_REGULAR_EXPRESSION "OK"
            LABELS "custom_device;almaif"
            ENVIRONMENT "POCL_DEVICES=almaif;POCL_ALMAIF0_PARAMETERS=0xB,${CMAKE_CURRENT_BINARY_DIR}/firmwares/${core_name},1,2,65535;POCL_ALMAIF0_HASH=${tta_device_hash}"
            DEPENDS "pocl_version_check;examples/example0")


    # Setup the standalone tests. The regular test will generate the standalone files
    set_property(TEST "examples/example0/ttasim_${core_name}"
        APPEND PROPERTY ENVIRONMENT "POCL_ALMAIF_STANDALONE=1")
    set_property(TEST "examples/example0/ttasim_${core_name}"
        PROPERTY FIXTURES_SETUP standalone_${core_name})

    # The actual standalone tests
    add_test_pocl(NAME "examples/example0/ttasim_standalone_${core_name}"
      COMMAND "run_standalone_ttasim.sh####${core_name}"
      WORKITEM_HANDLER "loopvec"
      EXPECTED_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/golden_output.txt")

    add_test_pocl(NAME "examples/example0/rtlsim_standalone_${core_name}"
      COMMAND "run_standalone_rtlsim.sh####${core_name}"
      WORKITEM_HANDLER "loopvec"
      EXPECTED_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/golden_output.txt")

    set_tests_properties ("examples/example0/ttasim_standalone_${core_name}" "examples/example0/rtlsim_standalone_${core_name}"
        PROPERTIES
            LABELS "custom_device;almaif"
            FIXTURES_REQUIRED standalone_${core_name})


endif()
    if (PYNQ_AVAILABLE)
	    add_test(NAME "upload_bitstream/pynq_${core_name}" COMMAND sudo -E python -c "from pynq import Overlay;Overlay(\'${CMAKE_CURRENT_BINARY_DIR}/bitstreams/${core_name}.bit\')" )
	    add_test(NAME "examples/accel/add.i32/pynq_${core_name}" COMMAND sudo -E ${CMAKE_CURRENT_BINARY_DIR}/accel_example pocl.add.i32)
	    add_test(NAME "examples/accel/mul.i32/pynq_${core_name}" COMMAND sudo -E ${CMAKE_CURRENT_BINARY_DIR}/accel_example pocl.mul.i32)
	    add_test(NAME "examples/example0/pynq_${core_name}" COMMAND sudo -E ${CMAKE_CURRENT_BINARY_DIR}/../example0/example0 b ${CMAKE_CURRENT_BINARY_DIR}/../accel/${core_name}_example0.poclbin)

        set_tests_properties( "examples/accel/add.i32/pynq_${core_name}" "examples/accel/mul.i32/pynq_${core_name}"
            "examples/example0/pynq_${core_name}"
            PROPERTIES
                PASS_REGULAR_EXPRESSION "OK"
                LABELS "custom_device;almaif"
                ENVIRONMENT "POCL_DEVICES=almaif;POCL_ALMAIF0_PARAMETERS=0x40000000,${CMAKE_CURRENT_BINARY_DIR}/firmware_imgs/${core_name},1,2,65535;POCL_ALMAIF0_HASH=${tta_device_hash}"
                DEPENDS "pocl_version_check;examples/example0"
                RESOURCE_LOCK fpga
                FIXTURES_REQUIRED upload_${core_name}_bitstream
                )
        set_tests_properties( "upload_bitstream/pynq_${core_name}"
            PROPERTIES
                RESOURCE_LOCK fpga
                FIXTURES_SETUP upload_${core_name}_bitstream)
    endif()
  endfunction()

  
  generate_firmware("axim_sep"                         "0x40000000" "1023" ""           ""           ""           "1"
      "AIABJEBHGIEFBLDHPHBFGPKMBNAOFJDEPBBFAIPI")
  generate_firmware("axim_fused_global_cq"             "0x40000000" "3"    "0x4001FF00" ""           ""           "1"
      "FHDGLEPJNNDDHJEICNEJPOIFAKMNOIHMAHGCPMHB")
  generate_firmware("axim_fused_global_private"        "0x40000000" "1023" ""           "0x40020000" "0x4001F800" "1"
      "NJIDHFMAAAKJLALCOMLBFBHDHADBMLCIJKDMPCLL")
  generate_firmware("axim_fused_global_cq_private"     "0x40000000" "3"    "0x4001F700" "0x40020000" "0x4001F800" "1"
      "FGKACOBAEPKBCNPFKHAKMMBAJLLIDCFOMICIOELN")

=== examples/boxadd/CMakeLists.txt ===
#=============================================================================
#   CMake build system files
#
#   Copyright (c) 2018 pocl developers
#
#   Permission is hereby granted, free of charge, to any person obtaining a copy
#   of this software and associated documentation files (the "Software"), to deal
#   in the Software without restriction, including without limitation the rights
#   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#   copies of the Software, and to permit persons to whom the Software is
#   furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#   THE SOFTWARE.
#
#=============================================================================

add_compile_options(${OPENCL_CFLAGS})

if (MSVC)
  set_source_files_properties( boxadd.c boxadd_exec.c PROPERTIES LANGUAGE CXX )
endif(MSVC)
add_executable("boxadd" boxadd.c boxadd_exec.c boxadd.cl)

target_link_libraries("boxadd" ${POCLU_LINK_OPTIONS})

add_test(NAME "examples/boxadd" COMMAND "boxadd")

set(PROPS)
if(NOT ENABLE_ANYSAN)
  set(PROPS
    PASS_REGULAR_EXPRESSION "OK")
endif()

set_tests_properties( "examples/boxadd"
  PROPERTIES
    COST 3.0
    ${PROPS}
    PROCESSORS 1
    LABELS "internal;vulkan;level0"
    DEPENDS "pocl_version_check")

=== debian/changelog ===
pocl (6.0-7) unstable; urgency=medium

  * Build with -DENABLE_CONFORMANCE=ON.
  * Build with g++-14.  (Closes: #1097627)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 05 Sep 2025 16:31:05 +0200

pocl (6.0-6) unstable; urgency=medium

  * Add runtime dependency on llvm-spirv.
  * Expect the spirv tests to fail on 32-bit architectures. (Closes: #1101871)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Apr 2025 07:32:27 +0200

pocl (6.0-5) unstable; urgency=medium

  * Update symbols file.  (Closes: #1097326)
  * Build with libllvmspirvlib-18-dev and llvm-spirv-18.
  * Build with libze-dev and -DENABLE_LEVEL0=ON.
  * libpocl-devices-level0: New package for the Level Zero device library.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 01 Mar 2025 02:58:05 +0100

pocl (6.0-4) unstable; urgency=medium

  * Update symbols file.
  * Drop unneeded -dev paragraph from -doc description.  (Closes: #1081689)
  * Cherry-pick commit from upstream that as a side effect fixed "LLVM ERROR:
    Instruction Combining did not reach a fixpoint after 1 iterations".
    (Closes: #1091190)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Jan 2025 12:44:04 +0100

pocl (6.0-3) unstable; urgency=medium

  * Switch to llvm 18.
  * Update symbols file for amd64 and i386.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 28 Sep 2024 21:54:32 +0200

pocl (6.0-2) unstable; urgency=medium

  * Do not treat x32 as i386.
  * Rebuild with GCC 14.  (Closes: #1075393)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 26 Jul 2024 04:30:59 +0200

pocl (6.0-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Jun 2024 11:29:13 +0200

pocl (6.0~rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Update symbols file for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 12 Jun 2024 13:30:11 +0200

pocl (5.0-4) unstable; urgency=medium

  * Switch to llvm 17.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 29 Apr 2024 22:56:01 +0200

pocl (5.0-3) unstable; urgency=medium

  * Switch B-D to pkgconf.
  * Cherry-pick upstream testcase and fix for region_entry_barrier assertion.
    (Closes: #1060318)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 22 Apr 2024 18:09:02 +0200

=== debian/control ===
Source: pocl
Section: libs
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders: Vincent Danjean <vdanjean@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 gcc (>= 4:14),
 g++-14,
 clang-18,
 libclang-18-dev,
 libclang-cpp18-dev,
 libllvmspirvlib-18-dev,
 llvm-18-dev,
 llvm-spirv-18,
 cmake,
 libhwloc-dev,
 libze-dev [amd64],
 ocl-icd-dev,
 ocl-icd-opencl-dev,
 pkgconf,
 pkg-kde-tools,
 clinfo <!nocheck>,
# prevent accidental backports after the 64-bit time_t transition
 dpkg-dev (>= 1.22.5),
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 python3-sphinx <!nodoc>,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://portablecl.org
Vcs-Browser: https://salsa.debian.org/opencl-team/pocl
Vcs-Git: https://salsa.debian.org/opencl-team/pocl.git

Package: pocl-opencl-icd
Architecture: any
Multi-Arch: same
Depends:
 libpocl2t64 (= ${binary:Version}),
 ${misc:Depends}
Provides:
 opencl-icd,
 opencl-icd-1.1-1,
 opencl-icd-1.2-1,
Description: PoCL ICD
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package allows one to use PoCL as an installable client driver (ICD) for
 OpenCL.

Package: libpocl2-common
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 ${misc:Depends}
Breaks:
 libpocl1-common,
Replaces:
 libpocl1-common,
Description: common files for the PoCL library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package provides the architecture independent files of the PoCL library.

Package: libpocl2t64
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libpocl2-common (= ${source:Version}),
 clang-${LLVM:Version},
 llvm-spirv-${LLVM:Version},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 pocl-opencl-icd,
Breaks:
 libpocl2 (<< ${source:Version}),
 libpocl1-common (<< 0.13-9),
Replaces:
 libpocl2,
 libpocl1-common (<< 0.13-9),
Provides: ${t64:Provides},
 libpocl2+llvm${LLVM:Version},
Description: Portable Computing Language library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations. A "native" target is included,
 which allows running OpenCL kernels on the host (CPU).
 .
 This package provides the core of PoCL.

Package: libpocl-devices-level0
Architecture: amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libpocl2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 pocl-opencl-icd,
Description: Portable Computing Language library - Level Zero device library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package provides the Level Zero device library.

Package: libpocl-dev
Architecture: any
Section: libdevel
Depends:
 libpocl2t64 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: development files for the PoCL library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package provides the development files for the PoCL library. Unless very
 specific needs, this package is useless. This package is only required to link
 directly and explicitly with PoCL.
 .
 To develop OpenCL programs (that can be run with PoCL), the opencl-dev virtual
 package (provided by ocl-icd-opencl-dev for example) is required, not this one.

Package: pocld
Architecture: any
Depends:
 ${misc:Depends}
Description: dummy pocld for PoCL-R
 Dummy package, will contain pocld from PoCL 6.1.

Package: pocl-tests
Architecture: all
Multi-Arch: foreign
Section: devel
Depends:
 ${misc:Depends}
Description: PoCL testsuite
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package contains the source code of the PoCL test suite.

Package: pocl-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Build-Profiles: <!nodoc>
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for the PoCL library
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package provides the documentation for the PoCL library.

Package: pocl-source
Architecture: all
Multi-Arch: foreign
Section: devel
Depends:
 ${misc:Depends}
Provides:
 pocl-source-${source:Upstream-Version:pkgname},
Description: PoCL source code
 Portable Computing Language is an open source implementation of the OpenCL
 standard which can be easily adapted for new targets. One of the goals of the
 project is improving performance portability of OpenCL programs, avoiding the
 need for target-dependent manual optimizations.
 .
 This package provides original Debian (with Debian patches already applied)
 sources of PoCL shipped in a tarball. This can be used for building the
 device libraries for additional targets.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
export CXX = g++-14
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

LLVM_VERSION			 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)

LLVM_ARCH-amd64			 = distro
#LLVM_ARCH-amd64			 = x86-64
#LLVM_ARCH-arm64			 = generic
LLVM_ARCH-armel			 = arm946e-s		# arch=armv5te
# armhf should rather be arch=armv7-a, e.g. cpu=cortex-a5 or similar with attr=+vfp3,+d16,+thumb2,-neon,-vfp4
LLVM_ARCH-armhf			 = arm1156t2f-s
LLVM_ARCH-hurd-amd64		 = $(LLVM_ARCH-amd64)
LLVM_ARCH-hurd-i386		 = $(LLVM_ARCH-i386)
LLVM_ARCH-i386			 = distro
#LLVM_ARCH-i386			 = i686			# clang targets pentium4 by default
LLVM_ARCH-kfreebsd-amd64	 = $(LLVM_ARCH-amd64)
LLVM_ARCH-kfreebsd-i386		 = $(LLVM_ARCH-i386)
#LLVM_ARCH-mips			 = mips32r2 # guess
#LLVM_ARCH-mips64el		 = mips64r2 # guess
#LLVM_ARCH-mipsel		 = mips32r2 # guess
#LLVM_ARCH-powerpc		 = ppc
#LLVM_ARCH-ppc64			 = ppc64 # guess
#LLVM_ARCH-ppc64el		 = ppc64le
#LLVM_ARCH-s390x			 = z10
#LLVM_ARCH-sparc64		 = v8 # guess
LLVM_ARCH-x32			 = $(LLVM_ARCH-amd64)

LLC_HOST_CPU	 = $(or $(patsubst pocl_cpu=%,%,$(filter pocl_cpu=%,$(DEB_BUILD_OPTIONS))),$(LLVM_ARCH-$(DEB_HOST_ARCH)),GENERIC)

# NEON, optional for Debian, must not be used
EXTRA_HOST_CLANG_FLAGS-armhf	 = -mfpu=vfp3-d16
# TODO: export KERNEL_LIB_OPT_FLAGS= -mattr=-neon,+d16,+vfp3,-vfp4,+v7,+aclass,+thumb2

# doc for symbols:
# http://www.eyrie.org/~eagle/journal/2012-01/008.html
# main packaging script based on dh7 syntax
%:
	dh $@ --with pkgkde_symbolshelper

getval			 = $(or $($1-$(DEB_HOST_ARCH)),$($1))
var2flag		 = $(if $(strip $(call getval,$1)),-D$1="$(call getval,$1)")
POCL_CONFIGURE_FLAGS	 =
POCL_CONFIGURE_FLAGS	+= -DENABLE_ICD=ON
POCL_CONFIGURE_FLAGS	+= -DWITH_LLVM_CONFIG=/usr/bin/llvm-config-$(LLVM_VERSION)
POCL_CONFIGURE_FLAGS	+= $(if $(filter distro,$(LLC_HOST_CPU)),-DLLC_HOST_CPU=GENERIC -DKERNELLIB_HOST_CPU_VARIANTS=distro,-DLLC_HOST_CPU=$(LLC_HOST_CPU))
POCL_CONFIGURE_FLAGS	+= $(call var2flag,EXTRA_HOST_CLANG_FLAGS)
POCL_CONFIGURE_FLAGS	+= -DPOCL_ICD_ABSOLUTE_PATH=OFF
POCL_CONFIGURE_FLAGS	+= -DHARDENING_ENABLE=ON
POCL_CONFIGURE_FLAGS	+= -DENABLE_CONFORMANCE=ON
POCL_CONFIGURE_FLAGS	+= -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF
ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf))
POCL_CONFIGURE_FLAGS	+= -DPRINTF_BUFFER_SIZE=4096
endif
ifneq (,$(filter $(DEB_HOST_ARCH),amd64))
POCL_CONFIGURE_FLAGS	+= -DENABLE_LEVEL0=ON
endif

execute_before_dh_auto_configure:
	mkdir -p build-source
	tar \
		--owner=0 --group=0 \
		--transform 's,^,pocl/,' \
		--exclude=debian \
		--exclude=build-source \
		--sort=name \
		--mtime=@$(SOURCE_DATE_EPOCH) \
		--clamp-mtime \
		--mode=u+rw,go+r,go-w,a-s \
		-cf - * | xz > build-source/pocl.tar.xz

execute_after_dh_auto_clean:
	$(RM) -r build-source

override_dh_auto_configure:
	@echo Using LLC_HOST_CPU=$(LLC_HOST_CPU)
	-/usr/lib/llvm-$(LLVM_VERSION)/bin/llc -version
	-/usr/lib/llvm-$(LLVM_VERSION)/bin/llc -mattr=help
	dh_auto_configure -- $(POCL_CONFIGURE_FLAGS)
	cat obj-$(DEB_HOST_GNU_TYPE)/config.h

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	sphinx-build -N -b html doc/sphinx/source build-doc/html
endif

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/$(DEB_HOST_MULTIARCH)/pocl -- --warnings=7

override_dh_auto_test-indep:
override_dh_auto_test-arch:
	# Failure in testsuite is delayed until symbols handling
	# and all files are logged.
	$(RM) debian/stamp-failed-testsuite
	$(RM) -r debian/kcache
	@set -ex; for k in $$(sed -r -n '/KERNELLIB_HOST_CPU_VARIANTS/ { s/.*"(.*)".*/\1/; s/;/ /g; p }' obj-$(DEB_HOST_GNU_TYPE)/config.h) ; \
		do echo TESTING $$k ; \
		env POCL_KERNELLIB_NAME=$$k \
		    POCL_CACHE_DIR=$(CURDIR)/debian/kcache/$$k \
		$(MAKE) -f debian/rules run-tests ; \
	done
	$(RM) -r debian/kcache

run-tests:
	env	OCL_ICD_VENDORS=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/ocl-vendors/pocl-tests.icd \
		POCL_BUILDING=1 \
		POCL_DEVICES=basic \
		clinfo || touch debian/stamp-failed-testsuite
	env	OCL_ICD_VENDORS=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/ocl-vendors/pocl-tests.icd \
		POCL_BUILDING=1 \
		clinfo || touch debian/stamp-failed-testsuite
	@set -ex; if ! dh_auto_test ; then \
		echo "***** The testsuite has failed! *****" ; \
		touch debian/stamp-failed-testsuite; \
	fi

run_dh_makeshlibs:
	dh_makeshlibs

delayed_check_dh_auto_test_result: run_dh_makeshlibs
	@set -ex; if test -f debian/stamp-failed-testsuite ; then \
		echo "***** The testsuite has failed! *****" ; \
		exit 1 ; \
	fi
	@test -f obj-*/Testing/Temporary/LastTest.log && echo 'The testsuite has passed all tests.' || echo '*** The testsuite was *NOT* run! ***'

override_dh_makeshlibs: run_dh_makeshlibs delayed_check_dh_auto_test_result

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'LLVM:Version=$(LLVM_VERSION)' \
		-V'source:Upstream-Version:pkgname=$(subst ~,-,$(DEB_VERSION_UPSTREAM))' \


fix-symbols:
	pkgkde-getbuildlogs
	echo "pkgkde-symbolshelper batchpatch -v $(DEB_VERSION_EPOCH_UPSTREAM) pocl_$(DEB_DISTRIBUTION)_logs/pocl_$(DEB_VERSION)_*build"

=== debian/watch ===
version=4
opts="uversionmangle=s/-RC(\d*)/~rc$1/, filenamemangle=s/-RC(\d*)/~rc$1/;s%(?:^.*?/)?v?(\d[\d.\~rc]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/pocl/pocl/tags \
   (?:.*?/)?v?(\d[\d.RC-]*)\.tar\.gz
